# final_review_test.py

from final_review_solutions import *

def test_secret_message():

    # Case 1:
    msg = "<< Good Job >>"
    assert secret_message(msg) == "Good Job", "Case 1 failed"

    # Case 2:
    msg = "<<>>"
    assert secret_message(msg) == "", "Case 2 failed"

    # Case 3:
    msg = "<< gg >>Good Job >>"
    assert secret_message(msg) == "gg >>Good Job", "Case 3 failed"

    # Case 4:
    msg = "<< << gg >>Awesome Job"
    assert secret_message(msg) == "<< gg", "Case 4 failed"

def test_max_cols():

    # Case 1:
    table = [[1],[2],[3]]
    assert max_cols(table) == [3], "Case 1 failed"

    # Case 2:
    table = [[1,2,3]]
    assert max_cols(table) == [1,2,3], "Case 2 failed"

    # Case 3:
    table = [[1,2,3],[4,5,6],[7,8,9]]
    assert max_cols(table) == [7,8,9], "Case 3 failed"

    # Case 4:
    table = [[1,2,3],[1,2,3],[1,2,3]]
    assert max_cols(table) == [1,2,3], "Case 4 failed"

    # Case 5:
    table = [[3,2,1],[1,2,3],[1,3,2]]
    assert max_cols(table) == [3,3,3], "Case 5 failed"

def test_wellformatted():

    #Case 1:
    input = ['VP', ['V', 'eat']]
    labels = ['VP', 'V']
    assert wellformatted(input,labels) == True, "Case 1 failed"

    #Case 2:
    input = ['NP', ['N', 'a', 'or', 'b'], 'c']
    labels =  ['NP', 'V', 'N']
    assert wellformatted(input,labels) == True, "Case 2 failed"

    #Case 3:
    input = [1, [2, 'oui', [1, 'no']], 'no']
    labels =  [1,2]
    assert wellformatted(input,labels) == True, "Case 3 failed"

    #Case 4:
    input = ['VP', ['V', 'eat']]
    labels =  ['VP']
    assert wellformatted(input,labels) == False, "Case 4 failed"

    #Case 5:
    input = ['VP', ['V']]
    labels =  ['VP', 'V']
    assert wellformatted(input,labels) == False, "Case 5 failed"

    #Case 6:
    input = 'VP'
    labels =  ['VP', 'V']
    assert wellformatted(input,labels) == False, "Case 6 failed"

def test_duplicate_again():

    #Case 1: empty list
    nums = []
    a = 1
    duplicate_again(nums,a)
    assert nums == [], "Case 1 failed"

    #Case 2: list of only 'a'
    nums = [1]
    a = 1
    duplicate_again(nums,a)
    assert nums == [1], "Case 2 failed"

    #Case 3: list of one element that is not 'a'
    nums = [1,2,1]
    a = 1
    duplicate_again(nums,a)
    assert nums == [1,2,2,1], "Case 3 failed"

    #Case 4: list of all elements that are not 'a'
    nums = [2,3,4]
    a = 1
    duplicate_again(nums,a)
    assert nums == [2,2,3,3,4,4], "Case 4 failed"

print("Starting tests")
print()

print("Testing secret_message()")
test_secret_message()
print("Testing max_cols()")
test_max_cols()
print("Testing wellformatted()")
test_wellformatted()
print('Testing duplicate_again()')
test_duplicate_again()

print()
print("Passed all tests!")
